#include "label.h"

#include <string.h>
#include <utils/p2c.h>
#include <utils/strings.h>
#include <graphics/newkbd.h>
#include <graphics/newci.h>
#include "settings.h"
#include "logglobals.h"
#include "logfont.h"
#include "utils.h"
#include "page.h"
#include "window.h"
#include "log.h"
#include "keyboard.h"
#include "pen.h"


/**
	@param lbl: list of character to parse
	@param numattrs: number of found attributs
	@param attr: vector containing parsed attributs
 */
void parselabel(strlist_t **lbl, short *numattrs, log_kattrrec **attr)
{
	size_t maxx, j1, j, j2, j3, yy;
	strlist_t *l1, *l2, *l3, *attrnames;
	char buf[256];
	int haveprec;
	log_kattrrec *WITH;
	char STR1[256];
	char STR2[256];
	size_t FORLIM;

	j = 1;
	*numattrs = 0;
	attrnames = NULL;
	l1 = *lbl;
	// boucle qui compte le nombre d'attribut
	while (l1 != NULL) {
		j = strposc(l1->s, ':', 1L);
		if (j != 0 && j != strpos2(l1->s, "::", 1))
			(*numattrs)++;

		l1->value = (na_long)strlen(l1->s);
		l1 = l1->next;
	}
	*attr = (log_kattrrec *)Malloc(*numattrs * kattrrecsize);
	maxx = 0;
	l1 = *lbl;
	j = 1;
	yy = 0;
	// On parcours de nouveau la liste de string
	while (l1 != NULL)
	{
		j1 = strposc(l1->s, ':', 1L);
		// Si c'est bien un attribut
		if (j1 != 0 && j1 != strpos2(l1->s, "::", 1))
		{
			WITH = &(*attr)[j - 1];
			WITH->vr = 0;
			WITH->vra = 0;
			strcpy(STR1, strltrim(l1->s));
			strcpy(l1->s, STR1); // TODO optimiser
			// elimine les [ ] si autour de l'attribut
			while (l1->s[0] == '[')
			{
				j2 = strposc(l1->s, ']', 1L);
				if (j2 < 3)
					continue;
				l2 = strlist_append(&attrnames, strpart(STR1, l1->s, 2, j2 - 1));
				l2->value = (na_long)((long)j);
				strcpy_overlap(l1->s, l1->s + j2);
				strcpy(STR1, strltrim(l1->s));
				strcpy(l1->s, STR1); // TODO optimiser
			}
			j2 = strposc(l1->s, ';', 1L);
			if (j2 != 0 && j2 < j1)
			{
				sprintf(buf, "%.*s", j2 - 1, l1->s);
				strrtrim(buf);
				j3 = 1;
				// Recherche si l'attribut à déjà été défini
				while (j3 < j && WITH->vra == 0)
				{
					if ((*attr)[j3 - 1].dtype == 'V')
					{
						l2 = (*attr)[j3 - 1].UU.U86.v;
						while (l2 != NULL && strcicmp(l2->s, buf) != 0)
							l2 = l2->next;

						if (l2 != NULL) {
							WITH->vr = (long)l2->value;
							WITH->vra = j3;
						}
					}
					j3++;
				}
				strcpy_overlap(l1->s, l1->s + j2);
			}
			if (l1->s[0] == ' ')
			{
				strcpy(STR1, strltrim(l1->s));
				strcpy(l1->s, STR1); // TODO optimiser
			}
			WITH->prec = 0;
			haveprec = false;
			while (isdigit(l1->s[0]))
			{
				WITH->prec = WITH->prec * 10 + l1->s[0] - 48;
				haveprec = true;
				strcpy_overlap(l1->s, l1->s + 1);
			}
			if (l1->s[0] == ' ')
			{
				strcpy(STR1, strltrim(l1->s));
				strcpy(l1->s, STR1);
			}
			WITH->opt = false;
			do
			{
				WITH->dtype = toupper(l1->s[0]);
				if (l1->s[0] != ':')
				{
					do
					{
						strcpy_overlap(l1->s, l1->s + 1);
					}
					while (l1->s[0] == ' ');
				}
				if (WITH->dtype == 'O')
					WITH->opt = true;

			}
			while (WITH->dtype == 'O');

			if (WITH->dtype == 'F' || WITH->dtype == 'U' || WITH->dtype == 'R')
			{
				*WITH->UU.U82.u = '\0';
				if (WITH->dtype == 'F' || WITH->dtype == 'U')
				{
					while (l1->s[0] != ',' && l1->s[0] != ':')
					{
						if (l1->s[0] != ' ' && strlen(WITH->UU.U82.u) < 3)
							sprintf(WITH->UU.U82.u + strlen(WITH->UU.U82.u), "%c", l1->s[0]);

						strcpy_overlap(l1->s, l1->s + 1);
					}
					if (l1->s[0] == ',')
						strcpy_overlap(l1->s, l1->s + 1);

					strcpy(STR1, strltrim(l1->s));
					strcpy(l1->s, STR1);
				}
				*buf = '\0';
				while (l1->s[0] != ':')
				{
					sprintf(buf + strlen(buf), "%c", l1->s[0]);
					strcpy_overlap(l1->s, l1->s + 1);
				}
				WITH->UU.U82.r = 0.0;
				WITH->blnk = true;
				if (*buf != '\0')
				{
					readreal(buf, &WITH->UU.U82.r);
					WITH->blnk = false;
				}
				if (!haveprec)
					WITH->prec = 0;

			}
			else if (WITH->dtype == 'I')
			{
				WITH->UU.U73.i1 = 0;
				WITH->blnk = true;
				while (isdigit(l1->s[0]))
				{
					WITH->UU.U73.i1 = WITH->UU.U73.i1 * 10 + l1->s[0] - 48;
					strcpy_overlap(l1->s, l1->s + 1);
					WITH->blnk = false;
				}
				if (!haveprec)
					WITH->prec = 1;

			}
			else if (WITH->dtype == 'H')
			{
				WITH->UU.U73.i1 = 0;
				j1 = 0;
				WITH->blnk = true;
				while ((l1->s[0] >= 'a' && l1->s[0] <= 'f') ||
						(l1->s[0] >= 'A' && l1->s[0] <= 'F') || isdigit(l1->s[0]))
				{
					WITH->UU.U73.i1 = WITH->UU.U73.i1 * 10 + l1->s[0] - 48;
					if (l1->s[0] >= 'A')
						WITH->UU.U73.i1 -= 7;

					if (l1->s[0] >= 'a')
						WITH->UU.U73.i1 -= 32;

					strcpy_overlap(l1->s, l1->s + 1);
					j1++;
					WITH->blnk = false;
				}
				if (!haveprec)
				{
					if (j1 != 0)
						WITH->prec = j1;
					else
						WITH->prec = 1;
				}
			}
			else if (WITH->dtype == 'C')
			{
				j1 = strposc(l1->s, ':', 1L);
				sprintf(buf, "%.*s", j1 - 1, l1->s);
				strrtrim(buf);
				strcpy_overlap(l1->s, l1->s + j1 - 1);
				if (!haveprec)
					WITH->prec = 255;

				if (strlen(buf) > WITH->prec)
					buf[WITH->prec] = '\0';

				WITH->UU.c = (char *)Malloc(WITH->prec + 1L);
				strcpy(WITH->UU.c, buf);
				WITH->blnk = (*buf == '\0');
			}
			else if (WITH->dtype == 'A')
			{
				j1 = strposc(l1->s, ':', 1L);
				sprintf(buf, "%.*s", j1 - 1, l1->s);
				strrtrim(buf);
				strcpy_overlap(l1->s, l1->s + j1 - 1);
				WITH->prec = 255;
				WITH->UU.sp = strdup(buf);
				WITH->blnk = (*buf == '\0');
			}
			else if (WITH->dtype == 'B')
			{
				WITH->blnk = false;
				if (l1->s[0] == 'y' || l1->s[0] == 'Y' || l1->s[0] == 't' || l1->s[0] == 'T')
					WITH->UU.b = true;
				else if (l1->s[0] == 'n' || l1->s[0] == 'N' || l1->s[0] == 'f' || l1->s[0] == 'F')
					WITH->UU.b = false;
				else
					WITH->blnk = true;

				if (l1->s[0] == 'x' || l1->s[0] == 'X' || l1->s[0] == 'f' ||
						l1->s[0] == 'F' || l1->s[0] == 't' || l1->s[0] == 'T')
					WITH->prec = 2;
				else
					WITH->prec = 1;
			}
			else if (WITH->dtype == 'V')
			{
				strlist_init(&l2);
				WITH->UU.U86.nv = 0;
				do
				{
					*buf = '\0';
					while (l1->s[0] != ',' && l1->s[0] != ':')
					{
						sprintf(buf + strlen(buf), "%c", l1->s[0]);
						strcpy_overlap(l1->s, l1->s + 1);
					}
					if (l1->s[0] == ',')
						strcpy_overlap(l1->s, l1->s + 1);

					l3= strlist_append(&l2,strcpy(STR1, strltrim(strrtrim(strcpy(STR2, buf)))));
					l3->value = (na_long)((long)WITH->UU.U86.nv);
					WITH->UU.U86.nv++;
					strcpy(STR1, strltrim(l1->s));
					strcpy(l1->s, STR1);
				}
				while (l1->s[0] != ':');
				WITH->UU.U86.v = l2;
				WITH->blnk = false;
				if (haveprec)
					WITH->UU.U86.dv = WITH->prec;
				else
					WITH->UU.U86.dv = 0;

				WITH->prec = 1;
			}
			else
			{
				WITH->dtype = 'R';
				WITH->UU.U82.r = 0.0;
				WITH->blnk = true;
				if (!haveprec)
					WITH->prec = 0;
			}
			if (WITH->blnk)
				WITH->opt = true;

			j1 = strposc(l1->s, ':', 1L);
			strcpy_overlap(l1->s, l1->s + j1);
			j++;
			WITH->y = yy;
			if (strlen(l1->s) > maxx)
				maxx = strlen(l1->s);

		}
		j1 = 1;
		while (j1 < strlen(l1->s))
		{
			if (l1->s[j1 - 1] == ':' && l1->s[j1] == ':')
				strcpy_overlap(l1->s + j1 - 1, l1->s + j1);
			j1++;
		}
		yy++;
		l1 = l1->next;
	}
	if (attrnames != NULL) {
		l1 = strlist_insert(lbl, "");
		l1->kind = '\001';
		l1->value = (void *)attrnames;
	}
	FORLIM = *numattrs;
	for (j = 0; j < FORLIM; j++)
		(*attr)[j].x = maxx + 1;
}

/// Erase a text label from the screen.
void eralabel(log_lrec *l)
{
	m_color((long)gg.color.backgr);
	m_drawstr(l->x * gg.scale - gg.xoff, l->y * gg.scale - gg.yoff + 2,
			logfont_lfont, l->name);
}


/// XOR a text label onto the screen.
void xorlabel(short x, short y, log_lrec *l)
{
	m_colormode((long)m_xor);
	m_color((long)gg.color.labeltext);
	m_drawstr(x * gg.scale - gg.xoff, y * gg.scale - gg.yoff + 2, logfont_lfont,
			l->name);
	m_colormode((long)m_normal);
}

void linklabel(log_lrec *l)
{
	l->next = gg.pages[gg.curpage - 1]->lbase;
	gg.pages[gg.curpage - 1]->lbase = l;
	stamp(&gg.labelstamp);
}

/// Create a Label.
void newlabel(log_lrec **l)
{
	*l = (log_lrec *)Malloc(sizeof(log_lrec));
	(*l)->temp = (na_long)0;
	linklabel(*l);
}


/// Dispose of a text label.
void unlinklabel(log_lrec *l)
{
	log_lrec *l1;

	l1 = gg.pages[gg.curpage - 1]->lbase;
	while (l1 != NULL && l1->next != l)
		l1 = l1->next;
	if (l1 == NULL)
		gg.pages[gg.curpage - 1]->lbase = l->next;
	else
		l1->next = l->next;
	chpageplace(gg.pages[gg.curpage - 1], l->x, l->y, l->x + l->w, l->y + 2);
	stamp(&gg.labelstamp);
}


void displabel(log_lrec **l)
{
	unlinklabel(*l);
	Free(*l);
	l = NULL;
}

void addlabelat(short x, short y, char *s)
{
	log_lrec *l;

	newlabel(&l);
	strcpy(l->name, s);
	l->x = x;
	l->y = y;
	l->w = m_strwidth(logfont_lfont, s) / log_scale0;
	chpageplace(gg.pages[gg.curpage - 1], x, y, x + l->w, y + 2);
	remcursor();
	clipon();
	m_color((long)gg.color.labeltext);
	m_drawstr(x * gg.scale - gg.xoff, y * gg.scale - gg.yoff + 2, logfont_lfont, s);
	clipoff();
	gg.nearlabel = l;
}


void addlabel(log_lrec **l, char *s)
{
	int conflict;
	log_lrec *l1;
	short x, y;

	x = 0;
	y = baseline - 15;
	do
	{
		fixxy(&x, &y);
		conflict = false;
		l1 = gg.pages[gg.curpage - 1]->lbase;
		while (l1 != NULL)
		{
			if (l1->y * gg.scale - gg.yoff == y &&
					labs(l1->x * gg.scale - gg.xoff - x) < 20)
				conflict = true;
			l1 = l1->next;
		}

		if (conflict)
		{
			y -= gg.scale * 2;
			if (y < 10)
			{
				y = baseline - 15;
				x += gg.scale * 20;
			}
		}
	} while (conflict);
	x = (x + gg.xoff) / gg.scale;
	y = (y + gg.yoff) / gg.scale;
	if (x * gg.scale < gg.xoff)
		x++;
	addlabelat(x, y, s);
	*l = gg.nearlabel;
}


#define blinkrate       25


/// Edit or create a label.
void editlabel(log_lrec *l)
{
	short i, x1, y1;
	long j;
	uchar ch;
	int redraw, touching;
	char name[log_lablen + 1];
	char STR1[256];

	m_graphics_on();
	clearalpha();
	remcursor();
	touching = (l != NULL && l == gg.nearlabel);
	if (l == NULL)
		addlabel(&l, "");
	x1 = l->x * gg.scale - gg.xoff;
	y1 = l->y * gg.scale - gg.yoff + 2;
	i = 1;
	strcpy(name, l->name);
	if (touching)
	{
		while (i <= strlen(name) &&
				gg.t.x - x1 > m_strwidth(logfont_lfont,
					(sprintf(STR1, "%.*s", i, name), STR1)))
		{
			i++;
		}
	}

	do
	{
		do
		{
			remcursor();
			clipon();
			m_colormode((long)m_xor);
			m_color((long)gg.color.labeltext);
			sprintf(STR1, "%.*s", i - 1, name);
			m_move(x1 + m_strwidth(logfont_lfont, STR1) - 1, y1 + 8L);
			if (i > strlen(name))
			{
				m_drawrel(6L, 0L);
			}
			else
			{
				sprintf(STR1, "%.1s", name + i - 1);
				m_drawrel(m_strwidth(logfont_lfont, STR1), 0L);
			}
			m_colormode((long)m_normal);
			clipoff();
			j = timers_sysclock() + blinkrate;
			if (!pollkbd2())
			{
				do
				{
					pass();
					pen();
				} while (!(pollkbd2() || gg.t.dn || timers_sysclock() > j));
			}
			remcursor();
			clipon();
			m_colormode((long)m_xor);
			m_color((long)gg.color.labeltext);
			sprintf(STR1, "%.*s", i - 1, name);
			m_move(x1 + m_strwidth(logfont_lfont, STR1) - 1, y1 + 8L);
			if (i > strlen(name))
			{
				m_drawrel(6L, 0L);
			}
			else
			{
				sprintf(STR1, "%.1s", name + i - 1);
				m_drawrel(m_strwidth(logfont_lfont, STR1), 0L);
			}
			m_colormode((long)m_normal);
			clipoff();
			j = timers_sysclock() + blinkrate;
			if (!(pollkbd2() || gg.t.dn))
			{
				do
				{
					pass();
					pen();
				} while (!(pollkbd2() || gg.t.dn || timers_sysclock() > j));
			}
		} while (!(pollkbd2() || gg.t.dn));

		if (!gg.t.dn)
		{
			ch = inkey2();
			if (ch >= 32 || ((1L << ch) & 0x10002108L) == 0)
			{
				remcursor();
				m_color((long)gg.color.backgr);
				m_drawstr((long)x1, (long)y1, logfont_lfont, name);
				redraw = true;
			}
			else
			{
				redraw = false;
			}

			if (ch >= ' ' && ch != 250 && ch != 251 && strlen(name) < log_lablen)
			{
				if (i <= strlen(name))
				{
					sprintf(STR1, " %s", name + i - 1);
					strcpy(name + i - 1, STR1);
				}
				else
				{
					strcat(name, " ");
				}
				name[i - 1] = ch;
				i++;
			}
			else if (ch == '\007' && i > 1)
			{
				i--;
				strcpy_overlap(name + i - 1, name + i);
			}
			else if (ch == '\030' && i <= strlen(name))
			{
				strcpy_overlap(name + i - 1, name + i);
			}
			else if (ch == '\b' && i > 1)
			{
				i--;
			}
			else if (ch == '\034' && i <= strlen(name))
			{
				i++;
			}
			else if (ch == '\031')
			{
				i = 1;
			}
			else if (ch == '\032')
			{
				i = strlen(name) + 1;
			}
			else if (ch == '\n' && strlen(name) < log_lablen)
			{
				sprintf(STR1, " %s", name + i - 1);
				strcpy(name + i - 1, STR1);
			}
			else if (ch == '\037' && i <= strlen(name) && strlen(name) > 1)
			{
				strcpy_overlap(name + i - 1, name + i);
			}
			if (redraw)
			{
				remcursor();
				m_color((long)gg.color.labeltext);
				m_drawstr((long)x1, (long)y1, logfont_lfont, name);
			}
		}
	} while (!((ch < 32 && ((1L << ch) & 0x2008) != 0) || gg.t.dn));

	if (*name == '\0')
	{
		displabel(&l);
	}
	else if (strcmp(name, l->name))
	{
		strcpy(l->name, name);
		l->w = m_strwidth(logfont_lfont, l->name) / log_scale0;
		stamp(&gg.labelstamp);
		chpageplace(gg.pages[gg.curpage - 1], l->x, l->y, l->x + l->w, l->y + 2);
	}
	gg.t.depressed = false;
	refreshsoon();
}

#undef blinkrate

